=== debian/changelog ===
pyside2 (5.14.0-1~exp1ubuntu5) focal; urgency=medium

  * No-change rebuild against qtbase-abi-5-12-8.

 -- Rik Mills <rikmills@kde.org>  Fri, 10 Apr 2020 23:28:03 +0100

pyside2 (5.14.0-1~exp1ubuntu4) focal; urgency=medium

  * No-change rebuild to drop python3.7.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 18 Feb 2020 15:33:12 +0100

pyside2 (5.14.0-1~exp1ubuntu3) focal; urgency=medium

  * Add missing test dep on python3-all.  Closes: #950127.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 17 Feb 2020 16:43:21 -0800

pyside2 (5.14.0-1~exp1ubuntu2) focal; urgency=medium

  * Drop python3-pyside2uic from autopkgtests.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 11 Feb 2020 00:13:30 +0000

pyside2 (5.14.0-1~exp1ubuntu1) focal; urgency=medium

  * Fix missing Breaks/Replaces for upgrading from previous version (Closes:
    #949339)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 29 Jan 2020 12:35:34 +0100

pyside2 (5.14.0-1~exp1build1) focal; urgency=medium

  * Ignore test failures for a first build.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 29 Jan 2020 08:05:25 +0100

pyside2 (5.14.0-1~exp1) experimental; urgency=medium

  [ Raphaël Hertzog ]
  * Team upload
  * New upstream version 5.14.0. Closes: #945376, #947101
  * Update patches (3 dropped, one new for Qt 5.12 compat)
  * Use --ignore-git option instead of custom patch
  * Update package names for version 5.14
  * Drop python3-pyside2uic, there's no such library anymore
  * Re-enable tests failing due to broken XDG_RUNTIME_DIR
  * Drop package prefix from lintian overrides
  * Drop removed file from debian/copyright
  * Fix arch-all build on 32 bit arches. Closes: #948764
    Thanks to peter green <plugwash@p10link.net> for the patch.

  [ Kurt Kremitzki ]
  * Add CMake sed for pyside2 include path
  * Add CMake sed for multi-Python version support

 -- Kurt Kremitzki <kurt@kwk.systems>  Mon, 13 Jan 2020 00:10:14 -0600
